//--------------------------------------------------------//
//  Copyright John D. Thompson                            //
//--------------------------------------------------------//
//Modified by GVC.....04/01/2015....
#property indicator_chart_window
#property copyright "NexGen4x Pty Ltd"
#property link      "http://www.nexgen4x.com"

// External Variables
extern color               SymbolColor = Silver;
extern color               Above = Green;
extern color               Below = Red;
extern color               Mixed = Yellow;
extern bool                PopUpAlerts = TRUE;
extern bool                SoundAlerts = FALSE;
extern bool                EmailAlerts = FALSE;
extern bool                AUDCAD = TRUE;
extern bool                AUDJPY = TRUE;
extern bool                AUDNZD = TRUE;
extern bool                AUDUSD = TRUE;
extern bool                CHFJPY = TRUE;
extern bool                EURCAD = TRUE;
extern bool                EURCHF = TRUE;
extern bool                EURGBP = TRUE;
extern bool                EURJPY = TRUE;
extern bool                EURUSD = TRUE;
extern bool                GBPCHF = TRUE;
extern bool                GBPJPY = TRUE;
extern bool                GBPUSD = TRUE;
extern bool                NZDUSD = TRUE;
extern bool                USDCAD = TRUE;
extern bool                USDCHF = TRUE;
extern bool                USDJPY = TRUE;

// Internal Variables
int                        spacer;
int                        sideways;
string                     ExtraSymbolChar;
string                     dash;
string                     Signal;
string                     LastSignal;
bool                       Row2 = FALSE;
string                     LastAlert;

int init() 
{
   ObjectsDeleteAll(0);
   Comment("\nFX 3Ducks Initialized,",
           "\n",
           "\nWaiting For Next Tick...");
   return (0);
}

int deinit() 
{
   ObjectsDeleteAll(0);
   return (0);
}

int start() 
{   
   Comment("\n");
   // Detects extra characters after symbol name.
   ExtraSymbolChar = StringSubstr(Symbol(), 6, 10);
   
   // Detects a dash in middle of symbol name.
   if (StringSubstr(Symbol(), 4, 1) == "-") dash = "-";
   else dash = "";
   
   SetTitles();
   spacer = 50;
   Row2 = FALSE;
   if (AUDCAD) ProcessSymbol("AUD"+dash+"CAD"+ExtraSymbolChar);
   if (AUDJPY) ProcessSymbol("AUD"+dash+"JPY"+ExtraSymbolChar);
   if (AUDNZD) ProcessSymbol("AUD"+dash+"NZD"+ExtraSymbolChar);
   if (AUDUSD) ProcessSymbol("AUD"+dash+"USD"+ExtraSymbolChar);
   if (CHFJPY) ProcessSymbol("CHF"+dash+"JPY"+ExtraSymbolChar);
   if (EURCAD) ProcessSymbol("EUR"+dash+"CAD"+ExtraSymbolChar);
   if (EURCHF) ProcessSymbol("EUR"+dash+"CHF"+ExtraSymbolChar);
   if (EURGBP) ProcessSymbol("EUR"+dash+"GBP"+ExtraSymbolChar);
   if (EURJPY) ProcessSymbol("EUR"+dash+"JPY"+ExtraSymbolChar);
   spacer = 50;
   Row2 = TRUE;
   if (EURUSD) ProcessSymbol("EUR"+dash+"USD"+ExtraSymbolChar);
   if (GBPCHF) ProcessSymbol("GBP"+dash+"CHF"+ExtraSymbolChar);
   if (GBPJPY) ProcessSymbol("GBP"+dash+"JPY"+ExtraSymbolChar);
   if (GBPUSD) ProcessSymbol("GBP"+dash+"USD"+ExtraSymbolChar);
   if (NZDUSD) ProcessSymbol("NZD"+dash+"USD"+ExtraSymbolChar);
   if (USDCAD) ProcessSymbol("USD"+dash+"CAD"+ExtraSymbolChar);
   if (USDCHF) ProcessSymbol("USD"+dash+"CHF"+ExtraSymbolChar);
   if (USDJPY) ProcessSymbol("USD"+dash+"JPY"+ExtraSymbolChar);
   
   

   ObjectCreate("Time", OBJ_LABEL, 0, 0, 0);
   ObjectSetText("Time", "Server Time: "+TimeToStr(TimeCurrent(),TIME_DATE|TIME_MINUTES), 9, "System", Orange); 
   ObjectSet("Time", OBJPROP_CORNER, 3);
   ObjectSet("Time", OBJPROP_XDISTANCE, 5);
   ObjectSet("Time", OBJPROP_YDISTANCE, 20);

   ObjectCreate("last", OBJ_LABEL, 0, 0, 0);
   ObjectSetText("last", "   Last Alert: "+LastAlert, 9, "System", Orange);
   ObjectSet("last", OBJPROP_CORNER, 2);
   ObjectSet("last", OBJPROP_XDISTANCE, 0);
   ObjectSet("last", OBJPROP_YDISTANCE, 50);
   
   ObjectCreate("copyright", OBJ_LABEL, 0, 0, 0);
   ObjectSetText("copyright", "   Copyright  www.nexgen4x.com ", 9, "System", Orange);
   ObjectSet("copyright", OBJPROP_CORNER, 2);
   ObjectSet("copyright", OBJPROP_XDISTANCE, 0);
   ObjectSet("copyright", OBJPROP_YDISTANCE, 20);
   Sleep(10000); 
   return(0);
}

int SetTitles()
{
   sideways = 0;
   spacer = 20;
   // Title
   ObjectCreate("Title", OBJ_LABEL, 0, 0, 0);
   ObjectSetText("Title", "   3 Ducks Indicator", 9, "System", Orange);
   ObjectSet("Title", OBJPROP_CORNER, 0);
   ObjectSet("Title", OBJPROP_XDISTANCE, sideways);
   ObjectSet("Title", OBJPROP_YDISTANCE, spacer);

   spacer = spacer + 30;
   // Pair Title
   ObjectCreate("Pair_Title", OBJ_LABEL, 0, 0, 0);
   ObjectSetText("Pair_Title", "   Pair", 9, "System", Orange);
   ObjectSet("Pair_Title", OBJPROP_CORNER, 0);
   ObjectSet("Pair_Title", OBJPROP_XDISTANCE, sideways);
   ObjectSet("Pair_Title", OBJPROP_YDISTANCE, spacer);

   // M5  
   sideways = sideways+110;
   ObjectCreate("M5_Title", OBJ_LABEL, 0, 0, 0);
   ObjectSetText("M5_Title", "M5", 9, "System", Orange);
   ObjectSet("M5_Title", OBJPROP_CORNER, 0);
   ObjectSet("M5_Title", OBJPROP_XDISTANCE, sideways);
   ObjectSet("M5_Title", OBJPROP_YDISTANCE, spacer);

   // H1  
   sideways = sideways+90;
   ObjectCreate("H1_Title", OBJ_LABEL, 0, 0, 0);
   ObjectSetText("H1_Title", "H1", 9, "System", Orange);
   ObjectSet("H1_Title", OBJPROP_CORNER, 0);
   ObjectSet("H1_Title", OBJPROP_XDISTANCE, sideways);
   ObjectSet("H1_Title", OBJPROP_YDISTANCE, spacer);
   
   // H4
   sideways = sideways+90;  
   ObjectCreate("H4_Title", OBJ_LABEL, 0, 0, 0);
   ObjectSetText("H4_Title", "H4", 9, "System", Orange);
   ObjectSet("H4_Title", OBJPROP_CORNER, 0);
   ObjectSet("H4_Title", OBJPROP_XDISTANCE, sideways);
   ObjectSet("H4_Title", OBJPROP_YDISTANCE, spacer); 
   
   // D1
   sideways = sideways+90;  
   ObjectCreate("D1_Title", OBJ_LABEL, 0, 0, 0);
   ObjectSetText("D1_Title", "D1", 9, "System", Orange);
   ObjectSet("D1_Title", OBJPROP_CORNER, 0);
   ObjectSet("D1_Title", OBJPROP_XDISTANCE, sideways);
   ObjectSet("D1_Title", OBJPROP_YDISTANCE, spacer); 
   
   // Last Signal
   sideways = sideways+90;  
   ObjectCreate("Last_Title", OBJ_LABEL, 0, 0, 0);
   ObjectSetText("Last_Title", "Last Signal", 9, "System", Orange);
   ObjectSet("Last_Title", OBJPROP_CORNER, 0);
   ObjectSet("Last_Title", OBJPROP_XDISTANCE, sideways);
   ObjectSet("Last_Title", OBJPROP_YDISTANCE, spacer);    

   spacer = 50;
   sideways = 550;
   // Pair Title
   ObjectCreate("Pair_Title2", OBJ_LABEL, 0, 0, 0);
   ObjectSetText("Pair_Title2", "   Pair", 9, "System", Orange);
   ObjectSet("Pair_Title2", OBJPROP_CORNER, 0);
   ObjectSet("Pair_Title2", OBJPROP_XDISTANCE, sideways);
   ObjectSet("Pair_Title2", OBJPROP_YDISTANCE, spacer);

   // M5  
   sideways = sideways+110;
   ObjectCreate("M5_Title2", OBJ_LABEL, 0, 0, 0);
   ObjectSetText("M5_Title2", "M5", 9, "System", Orange);
   ObjectSet("M5_Title2", OBJPROP_CORNER, 0);
   ObjectSet("M5_Title2", OBJPROP_XDISTANCE, sideways);
   ObjectSet("M5_Title2", OBJPROP_YDISTANCE, spacer);

   // H1  
   sideways = sideways+90; 
   ObjectCreate("H1_Title2", OBJ_LABEL, 0, 0, 0);
   ObjectSetText("H1_Title2", "H1", 9, "System", Orange);
   ObjectSet("H1_Title2", OBJPROP_CORNER, 0);
   ObjectSet("H1_Title2", OBJPROP_XDISTANCE, sideways);
   ObjectSet("H1_Title2", OBJPROP_YDISTANCE, spacer);

   // H4 
   sideways = sideways+90;  
   ObjectCreate("H4_Title2", OBJ_LABEL, 0, 0, 0);
   ObjectSetText("H4_Title2", "H4", 9, "System", Orange);
   ObjectSet("H4_Title2", OBJPROP_CORNER, 0);
   ObjectSet("H4_Title2", OBJPROP_XDISTANCE, sideways);
   ObjectSet("H4_Title2", OBJPROP_YDISTANCE, spacer);
   
   // D1
   sideways = sideways+90;  
   ObjectCreate("D1_Title2", OBJ_LABEL, 0, 0, 0);
   ObjectSetText("D1_Title2", "D1", 9, "System", Orange);
   ObjectSet("D1_Title2", OBJPROP_CORNER, 0);
   ObjectSet("D1_Title2", OBJPROP_XDISTANCE, sideways);
   ObjectSet("D1_Title2", OBJPROP_YDISTANCE, spacer);

   // Last Signal
   sideways = sideways+90;  
   ObjectCreate("Last_Title2", OBJ_LABEL, 0, 0, 0);
   ObjectSetText("Last_Title2", "Last Signal", 9, "System", Orange);
   ObjectSet("Last_Title2", OBJPROP_CORNER, 0);
   ObjectSet("Last_Title2", OBJPROP_XDISTANCE, sideways);
   ObjectSet("Last_Title2", OBJPROP_YDISTANCE, spacer); 
   
   return(0);    
}

int ProcessSymbol(string symbol){
   color D1_Color;
   color H4_Color;
   color H1_Color;
   color M5_Color;
   color Result_Color;
   string D1_Result;
   string H4_Result;
   string H1_Result;
   string M5_Result;
   double bid = MarketInfo(symbol, MODE_BID);  
   
   double iMA_D1 = iMA(symbol,PERIOD_D1,60,0,0,0,0);
   double iMA_H4 = iMA(symbol,PERIOD_H4,60,0,0,0,0);
   double iMA_H1 = iMA(symbol,PERIOD_H1,60,0,0,0,0);
   double iMA_M5 = iMA(symbol,PERIOD_M5,60,0,0,0,0);
 
   
   if(bid > iMA_D1){D1_Color = Above;D1_Result = "UP";}
    else 
      {D1_Color = Below;
      D1_Result = "DWN";}

   if (bid > iMA_H4) 
   {
      H4_Color = Above;
      H4_Result = "UP";
   } else {
      H4_Color = Below;
      H4_Result = "DWN";
   } 
   if (bid > iMA_H1) 
   {
      H1_Color = Above;
      H1_Result = "UP";
   } else {
      H1_Color = Below;
      H1_Result = "DWN";
   }
   if (bid > iMA_M5) 
   {
      M5_Color = Above;
      M5_Result = "UP";
   } else {
      M5_Color = Below;
      M5_Result = "DWN";
   }        

   ExtraSymbolChar = StringSubstr(Symbol(), 6, 10);

   // AUDCAD
   if (symbol == "AUD"+dash+"CAD"+ExtraSymbolChar)
   {
      if (M5_Result == "UP" && H1_Result == "UP" && H4_Result == "UP" && D1_Result == "UP")
      {
         Alerts(symbol,D1_Result);   
         LastSignal = "UP";        
      }
      else if (M5_Result == "DWN" && H1_Result == "DWN" && H4_Result == "DWN" && D1_Result == "DWN")
      {
         Alerts(symbol,D1_Result);
         LastSignal = "DWN";                
      }     
                        
      else {LastSignal = "NONE";}
     
   }
   
   // AUDJPY
   if (symbol == "AUD"+dash+"JPY"+ExtraSymbolChar)
   //LastSignal = AUDJPY_LastSignal;
   {
       if (M5_Result == "UP" && H1_Result == "UP" && H4_Result == "UP" && D1_Result == "UP")
      {
         Alerts(symbol,D1_Result);   
         LastSignal = "UP";        
      }
      else if (M5_Result == "DWN" && H1_Result == "DWN" && H4_Result == "DWN" && D1_Result == "DWN")
      {
         Alerts(symbol,D1_Result);
         LastSignal = "DWN";                
      }     
                        
      else {LastSignal = "NONE";}
   }
   
   // AUDNZD
   if (symbol == "AUD"+dash+"NZD"+ExtraSymbolChar)
   {
       if (M5_Result == "UP" && H1_Result == "UP" && H4_Result == "UP" && D1_Result == "UP")
      {
         Alerts(symbol,D1_Result);   
         LastSignal = "UP";        
      }
      else if (M5_Result == "DWN" && H1_Result == "DWN" && H4_Result == "DWN" && D1_Result == "DWN")
      {
         Alerts(symbol,D1_Result);
         LastSignal = "DWN";                
      }     
                        
      else {LastSignal = "NONE";}
   }
   
   // AUDUSD
   if (symbol == "AUD"+dash+"USD"+ExtraSymbolChar)
   {
      if (M5_Result == "UP" && H1_Result == "UP" && H4_Result == "UP" && D1_Result == "UP")
      {
         Alerts(symbol,D1_Result);   
         LastSignal = "UP";        
      }
      else if (M5_Result == "DWN" && H1_Result == "DWN" && H4_Result == "DWN" && D1_Result == "DWN")
      {
         Alerts(symbol,D1_Result);
         LastSignal = "DWN";                
      }     
                        
      else {LastSignal = "NONE";}
   }
   
   // CHFJPY
   if (symbol == "CHF"+dash+"JPY"+ExtraSymbolChar)
   {
      if (M5_Result == "UP" && H1_Result == "UP" && H4_Result == "UP" && D1_Result == "UP")
      {
         Alerts(symbol,D1_Result);   
         LastSignal = "UP";        
      }
      else if (M5_Result == "DWN" && H1_Result == "DWN" && H4_Result == "DWN" && D1_Result == "DWN")
      {
         Alerts(symbol,D1_Result);
         LastSignal = "DWN";                
      }     
                        
      else {LastSignal = "NONE";}
   }
   
   // EURCAD
   if (symbol == "EUR"+dash+"CAD"+ExtraSymbolChar)
   {
      if (M5_Result == "UP" && H1_Result == "UP" && H4_Result == "UP" && D1_Result == "UP")
      {
         Alerts(symbol,D1_Result);   
         LastSignal = "UP";        
      }
      else if (M5_Result == "DWN" && H1_Result == "DWN" && H4_Result == "DWN" && D1_Result == "DWN")
      {
         Alerts(symbol,D1_Result);
         LastSignal = "DWN";                
      }     
                        
      else {LastSignal = "NONE";}
   }
   
   // EURCHF
   if (symbol == "EUR"+dash+"CHF"+ExtraSymbolChar)
   {
       if (M5_Result == "UP" && H1_Result == "UP" && H4_Result == "UP" && D1_Result == "UP")
      {
         Alerts(symbol,D1_Result);   
         LastSignal = "UP";        
      }
      else if (M5_Result == "DWN" && H1_Result == "DWN" && H4_Result == "DWN" && D1_Result == "DWN")
      {
         Alerts(symbol,D1_Result);
         LastSignal = "DWN";                
      }     
                        
      else {LastSignal = "NONE";}
   }
   
   // EURGBP
   if (symbol == "EUR"+dash+"GBP"+ExtraSymbolChar)
   {
       if (M5_Result == "UP" && H1_Result == "UP" && H4_Result == "UP" && D1_Result == "UP")
      {
         Alerts(symbol,D1_Result);   
         LastSignal = "UP";        
      }
      else if (M5_Result == "DWN" && H1_Result == "DWN" && H4_Result == "DWN" && D1_Result == "DWN")
      {
         Alerts(symbol,D1_Result);
         LastSignal = "DWN";                
      }     
                        
      else {LastSignal = "NONE";}
   }
   
   // EURJPY
   if (symbol == "EUR"+dash+"JPY"+ExtraSymbolChar)
   {
      if (M5_Result == "UP" && H1_Result == "UP" && H4_Result == "UP" && D1_Result == "UP")
      {
         Alerts(symbol,D1_Result);   
         LastSignal = "UP";        
      }
      else if (M5_Result == "DWN" && H1_Result == "DWN" && H4_Result == "DWN" && D1_Result == "DWN")
      {
         Alerts(symbol,D1_Result);
         LastSignal = "DWN";                
      }     
                        
      else {LastSignal = "NONE";}
   }
   
   // EURUSD
   if (symbol == "EUR"+dash+"USD"+ExtraSymbolChar)
   {
      if (M5_Result == "UP" && H1_Result == "UP" && H4_Result == "UP" && D1_Result == "UP")
      {
         Alerts(symbol,D1_Result);   
         LastSignal = "UP";        
      }
      else if (M5_Result == "DWN" && H1_Result == "DWN" && H4_Result == "DWN" && D1_Result == "DWN")
      {
         Alerts(symbol,D1_Result);
         LastSignal = "DWN";                
      }     
                        
      else {LastSignal = "NONE";}
   }
   
   // GBPCHF
   if (symbol == "GBP"+dash+"CHF"+ExtraSymbolChar)
   {
       if (M5_Result == "UP" && H1_Result == "UP" && H4_Result == "UP" && D1_Result == "UP")
      {
         Alerts(symbol,D1_Result);   
         LastSignal = "UP";        
      }
      else if (M5_Result == "DWN" && H1_Result == "DWN" && H4_Result == "DWN" && D1_Result == "DWN")
      {
         Alerts(symbol,D1_Result);
         LastSignal = "DWN";                
      }     
                        
      else {LastSignal = "NONE";}
   }
   
   // GBPJPY
   if (symbol == "GBP"+dash+"JPY"+ExtraSymbolChar)
   {
      if (M5_Result == "UP" && H1_Result == "UP" && H4_Result == "UP" && D1_Result == "UP")
      {
         Alerts(symbol,D1_Result);   
         LastSignal = "UP";        
      }
      else if (M5_Result == "DWN" && H1_Result == "DWN" && H4_Result == "DWN" && D1_Result == "DWN")
      {
         Alerts(symbol,D1_Result);
         LastSignal = "DWN";                
      }     
                        
      else {LastSignal = "NONE";}
   }
   
   // GBPUSD
   if (symbol == "GBP"+dash+"USD"+ExtraSymbolChar)
   {
      if (M5_Result == "UP" && H1_Result == "UP" && H4_Result == "UP" && D1_Result == "UP")
      {
         Alerts(symbol,D1_Result);   
         LastSignal = "UP";        
      }
      else if (M5_Result == "DWN" && H1_Result == "DWN" && H4_Result == "DWN" && D1_Result == "DWN")
      {
         Alerts(symbol,D1_Result);
         LastSignal = "DWN";                
      }     
                        
      else {LastSignal = "NONE";}
   }
   
   // NZDUSD
   if (symbol == "NZD"+dash+"USD"+ExtraSymbolChar)
   {
       if (M5_Result == "UP" && H1_Result == "UP" && H4_Result == "UP" && D1_Result == "UP")
      {
         Alerts(symbol,D1_Result);   
         LastSignal = "UP";        
      }
     else if (M5_Result == "DWN" && H1_Result == "DWN" && H4_Result == "DWN" && D1_Result == "DWN")
      {
         Alerts(symbol,D1_Result);
         LastSignal = "DWN";                
      }     
                        
      else {LastSignal = "NONE";}
   }
   
   // USDCAD
   if (symbol == "USD"+dash+"CAD"+ExtraSymbolChar)
   {
      if (M5_Result == "UP" && H1_Result == "UP" && H4_Result == "UP" && D1_Result == "UP")
      {
         Alerts(symbol,D1_Result);   
         LastSignal = "UP";        
      }
      else if (M5_Result == "DWN" && H1_Result == "DWN" && H4_Result == "DWN" && D1_Result == "DWN")
      {
         Alerts(symbol,D1_Result);
         LastSignal = "DWN";                
      }     
                        
      else {LastSignal = "NONE";}
   }
   
   // USDCHF
   if (symbol == "USD"+dash+"CHF"+ExtraSymbolChar)
   {
       if (M5_Result == "UP" && H1_Result == "UP" && H4_Result == "UP" && D1_Result == "UP")
      {
         Alerts(symbol,D1_Result);   
         LastSignal = "UP";        
      }
      else if (M5_Result == "DWN" && H1_Result == "DWN" && H4_Result == "DWN" && D1_Result == "DWN")
      {
         Alerts(symbol,D1_Result);
         LastSignal = "DWN";                
      }     
                        
      else {LastSignal = "NONE";}
   }
   
   // USDJPY
   if (symbol == "USD"+dash+"JPY"+ExtraSymbolChar)
   {
       if (M5_Result == "UP" && H1_Result == "UP" && H4_Result == "UP" && D1_Result == "UP")
      {
         Alerts(symbol,D1_Result);   
         LastSignal = "UP";        
      }
      else if (M5_Result == "DWN" && H1_Result == "DWN" && H4_Result == "DWN" && D1_Result == "DWN")
      {
         Alerts(symbol,D1_Result);
         LastSignal = "DWN";                
      }     
                        
      else {LastSignal = "NONE";}
   }
   
   if (LastSignal == "UP") Result_Color = Above;
   if (LastSignal == "DWN") Result_Color = Below;
   if (LastSignal == "NONE") Result_Color = Mixed;
   
   spacer = spacer + 30;
   if (Row2) sideways = 550;
   else sideways = 0;
   ObjectCreate(symbol+"_Title", OBJ_LABEL, 0, 0, 0);
   ObjectSetText(symbol+"_Title", "   "+symbol, 9, "System", SymbolColor);
   ObjectSet(symbol+"_Title", OBJPROP_CORNER, 0);
   ObjectSet(symbol+"_Title", OBJPROP_XDISTANCE, sideways);
   ObjectSet(symbol+"_Title", OBJPROP_YDISTANCE, spacer);

   if (Row2) sideways = 660;
   else sideways = 110;
   ObjectCreate(symbol+"M5_Result", OBJ_LABEL, 0, 0, 0);
   ObjectSetText(symbol+"M5_Result", M5_Result, 9, "System", M5_Color);
   ObjectSet(symbol+"M5_Result", OBJPROP_CORNER, 0);
   ObjectSet(symbol+"M5_Result", OBJPROP_XDISTANCE, sideways);
   ObjectSet(symbol+"M5_Result", OBJPROP_YDISTANCE, spacer);

   if (Row2) sideways = 750;
   else sideways = 200;
   ObjectCreate(symbol+"H1_Result", OBJ_LABEL, 0, 0, 0);
   ObjectSetText(symbol+"H1_Result", H1_Result, 9, "System", H1_Color);
   ObjectSet(symbol+"H1_Result", OBJPROP_CORNER, 0);
   ObjectSet(symbol+"H1_Result", OBJPROP_XDISTANCE, sideways);
   ObjectSet(symbol+"H1_Result", OBJPROP_YDISTANCE, spacer);
   
   if (Row2) sideways = 840;
   else sideways = 290;   
   ObjectCreate(symbol+"H4_Result", OBJ_LABEL, 0, 0, 0);
   ObjectSetText(symbol+"H4_Result", H4_Result, 9, "System", H4_Color);
   ObjectSet(symbol+"H4_Result", OBJPROP_CORNER, 0);
   ObjectSet(symbol+"H4_Result", OBJPROP_XDISTANCE, sideways);
   ObjectSet(symbol+"H4_Result", OBJPROP_YDISTANCE, spacer);
   
    if (Row2) sideways = 930;
   else sideways = 380;   
   ObjectCreate(symbol+"D1_Result", OBJ_LABEL, 0, 0, 0);
   ObjectSetText(symbol+"D1_Result", D1_Result, 9, "System", D1_Color);
   ObjectSet(symbol+"D1_Result", OBJPROP_CORNER, 0);
   ObjectSet(symbol+"D1_Result", OBJPROP_XDISTANCE, sideways);
   ObjectSet(symbol+"D1_Result", OBJPROP_YDISTANCE, spacer);
   
   if (Row2) sideways = 1020;
   else sideways = 470;    
   ObjectCreate(symbol+"Last_Result", OBJ_LABEL, 0, 0, 0);
   ObjectSetText(symbol+"Last_Result", LastSignal, 9, "System", Result_Color);
   ObjectSet(symbol+"Last_Result", OBJPROP_CORNER, 0);
   ObjectSet(symbol+"Last_Result", OBJPROP_XDISTANCE, sideways);
   ObjectSet(symbol+"Last_Result", OBJPROP_YDISTANCE, spacer); 
   
   return(0);        
}

int Alerts(string symbol, string direction){

   if (PopUpAlerts) Alert("Quack .. Quack! 3 Ducks are "+direction+" on "+symbol);
   if (SoundAlerts) PlaySound("alert.wav");
   if (EmailAlerts) SendMail("3Ducks","Quack .. Quack! 3 Ducks are "+direction+" on "+symbol);
   LastAlert = direction+" on "+symbol;
   
   return(0);
}